.\"	$NetBSD: assert.3,v 1.12 2007/01/22 11:57:44 jdc Exp $
.\"
.\" Copyright (c) 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)assert.3	8.1 (Berkeley) 6/9/93
.\"
.Dd January 22, 2007
.Dt ASSERT 3
.Os
.Sh NAME
.Nm assert
.Nd expression verification macro
.Sh SYNOPSIS
.In assert.h
.Fn assert expression
.Sh DESCRIPTION
The
.Fn assert
macro tests the given
.Ar expression
and if it is false,
the calling process is terminated.
A diagnostic message, consisting of the text of the expression,
the name of the source file, the line number and the enclosing
function,
is written to
.Em stderr
and the
.Xr abort 3
function is called, effectively terminating the program.
.Pp
If
.Ar expression
is true,
the
.Fn assert
macro does nothing.
.Pp
The
.Fn assert
macro
may be removed at compile time with
the
.Xr cc 1
option
.Fl DNDEBUG .
.Sh DIAGNOSTICS
The following diagnostic message is written to
.Em stderr
if
.Ar expression
is false:
.Bd -literal -offset indent
"assertion \e"%s\e" failed: file \e"%s\e", line %d, function \e"%s\e"\en", \e
		    "expression", __FILE__, __LINE__, __func__);
.Ed
.Sh SEE ALSO
.Xr cc 1 ,
.Xr _DIAGASSERT 3 ,
.Xr abort 3
.Sh STANDARDS
The
.Fn assert
macro conforms to
.St -isoC-99 .
.Sh HISTORY
A
.Nm
macro appeared in
.At v6 .
.Pp
Information on the name of the enclosing function appeared in
.St -isoC-99 .
